use anyhow::Error;
use chrono::Utc;
use ulid::Ulid;

use super::Service;
use crate::domain::rolle::entity;
use crate::domain::rolle::model::RolleCreateInput;

impl Service {
    pub async fn create_rolle(&self, input: RolleCreateInput) -> Result<entity::Rolle, Error> {
        // let username_exists = self.check_username_exists(&self.db, &input.name).await?;
        // if username_exists {
        //     return Err(Error::UsernameAlreadyExists.into());
        // }

        let rolle_input = entity::Rolle {
            id: Ulid::new().into(),
            name: input.name,
            created_at: Utc::now(),
            updated_at: Utc::now(),
        };

        let rolle = self.repo.create_rolle(&self.db, &rolle_input).await?;
        Ok(rolle)
    }
}
